#! ruby -Ku
#ランダムハウス英語辞典を
#Mac OS X v10.5 "Leopard"の辞書アプリケーション（Dictionary.app）用のXMLに変換する
#by Tats_y (http://www.binword.com/blog/)
#v0.01
#2008/05/06

$KCODE = "UTF-8"

require 'iconv'
require 'nkf'

iconv = Iconv.new('UTF-8', 'CP932')

id = ""
title = ""
key = Array.new
body = ""

print '<?xml version="1.0" encoding="UTF-8"?>' + "\n"
print '<d:dictionary xmlns="http://www.w3.org/1999/xhtml" xmlns:d="http://www.apple.com/DTDs/DictionaryService-1.0.rng">' + "\n"

while line = gets
  next if line.strip.empty?  #空行を読み飛ばす
  line1 = iconv.iconv(line)  #読んだ行をUTF-8へ変換
  if line1 =~ /^<dt id=/ then
    id = line1.slice(/<dt id="([A-Za-z\d\.]+)">/, 1)  #idを取得
    title = line1.slice(/<dt id=".+?">(.+?)<\/dt>/, 1).gsub(/\{G99-8D\}/, "Ω")  #項目名を取得。Ωが外字扱いになっているので修正
  end
  if line1 =~ /^<key title=".+?" type="前方表記">/ then
    key.push(NKF.nkf('-wZ1', line1.slice(/<key title=".+?" type="前方表記">(.+)<\/key>/, 1).to_s))  #項目のキーを配列に格納
  end
  if line1 =~ /^<dd>/ then
    title2 = iconv.iconv(gets).gsub(/<br>|<nobr>|<\/nobr>/,"").strip.chomp  #本文の1行目はタイトルに使う
    if title2 !="" then
      title2 = "<span class=\"title2\">" +title2 + "</span><br/>\n"
    end
    body = "\t<p>\n" + title2
    while line2 = iconv.iconv(gets)
      if line2 =~ /^<\/p><\/dd>/ then
        body = body.gsub(/&#x1f09;&#x00;&#x02;|<nobr>|<\/nobr>/,"")      #各行に入っている余計な文字列を削除
        body = body.gsub(/&#x1f09;&#x00;&#x03;/,"&#x20;")      #各行に入っている余計な文字列を削除
        body = body.gsub(/<br>/, "<br/>")
        body = body.gsub(/<dfn>/, "<span class=\"dfn\" >")    # <dfn>タグが使えないのでスタイルシートに変換
        body = body.gsub(/<\/dfn>/, "<\/span>")
        body = body.gsub(/&nbsp;/, "&#x20;")    # &nbsp;だと認識されないので変換
        body = body.gsub(/(<img src=".+" alt=".+")>/) { $1 + "/>" }    # imgタグの末尾をきちんと「/」で閉じる
        body = body.gsub(/\{G99-8D\}/, "Ω")    # Ωの記号がなぜか外字になっているので修正
        body = body.gsub(/\t(【[0-9]+】.+)(<br\/>)?/) { "\t<span class=\"definition\">" + $1 + "</span>" + $2.to_s }    # 語義をスタイルシートで修飾
        body = body.gsub(/\t(━.+)<br\/>/) { "\t<span class=\"wordclass\">" + $1 + "</span><br/>" }    # 品詞をスタイルシートで修飾
        body = body.gsub(/\t<key title=".+?" type=".+?">.+?<\/key>/, "")    #条件検索用のキーワードなどを削除
        body = body + "\t</p>"  #末尾を</p>で閉じる
        body = body.gsub(/<a href="#([0-9A-Za-z\.]+)">/) { "<a href=\"x-dictionary:r:" + $1 + "\">"}  #リンクの形式を変換
        title3 = (title + title2.gsub(/<sub>|<\/sub>/, "")).gsub(/<a href=".+">.+<\/a>/, "").strip
        print '<d:entry id="' + id + '" d:title="' + title + "\">\n"
        if title !~ /&#xE[01][0-9a-fA-F]{2};/ then    # インデックス用キーワードに特殊な文字が入っているとエラーが起こるので、弾く
          print "\t<d:index d:value=\"" + title + '" d:title="' + title + "\"/>\n"
        end
        key.each { |elem|
          print "\t<d:index d:value=\"" + elem + "\" d:title=\"" + title +"\"/>\n"
        }
        print "\t<h1>" + title.strip + "</h1>\n"
        print body + "\n"
        print "</d:entry>\n"
        id = ""
        title = ""
        title2 = ""
        key = []
        body = ""
        break
      end
      body = body + "\t" + line2
    end
  end
end

print "</d:dictionary>\n"

