#! ruby -Ku
# UCS-4値をUTF-8に変換

def ucs4_to_utf8(code)

  def byte2hex(arg)
    return ("00000000" + arg).to_i(2)
  end

  ucs4_hex = code
  ucs4_dec = ucs4_hex.to_i(16)
  ucs4_str = ("00000000000000000000000000000000" + ucs4_dec.to_s(2))[-32,32]

  if (ucs4_dec < 0x00000080) then
    byte = ucs4_str[-8,8]
    hex = byte2hex(byte)
    chr = [hex].pack("C*")
  elsif (ucs4_dec < 0x000000800) then
    byte = "10" + ucs4_str[-6,6]
    hex1 = byte2hex(byte)
    byte = "110" + ucs4_str[-11,5]
    hex2 = byte2hex(byte)
    chr = [hex2, hex1].pack("C*")
  elsif (ucs4_dec < 0x00010000) then
    byte = "10" + ucs4_str[-6,6]
    hex1 = byte2hex(byte)
    byte = "10" + ucs4_str[-12,6]
    hex2 = byte2hex(byte)
    byte = "1110" + ucs4_str[-16,4]
    hex3 = byte2hex(byte)
    chr = [hex3, hex2, hex1].pack("C*")
  elsif (ucs4_dec < 0x00200000) then
    byte = "10" + ucs4_str[-6,6]
    hex1 = byte2hex(byte)
    byte = "10" + ucs4_str[-12,6]
    hex2 = byte2hex(byte)
    byte = "10" + ucs4_str[-18,6]
    hex3 = byte2hex(byte)
    byte = "11110" + ucs4_str[-21,3]
    hex4 = byte2hex(byte)
    chr = [hex4, hex3, hex2, hex1].pack("C*")
  end
  return chr
end

while line = gets
  print line.gsub(/&#x([0-9a-fA-F]{4});/) { ucs4_to_utf8($1) }
end
